This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 581181 - (scalpel) Review Request: scalpel - Forensic tool for file carving from disk images
Review Request: scalpel - Forensic tool for file carving from disk images
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
13
All Linux
low Severity medium
: ---
: ---
Assigned To: Pavel Alexeev
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-SECLAB
  Show dependency treegraph
 
Reported: 2010-04-10 17:21 EDT by Michal Ambroz
Modified: 2014-10-17 13:39 EDT (History)
5 users (show)

See Also:
Fixed In Version: scalpel-2.0-7.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-09-14 01:05:45 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
pahan: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Michal Ambroz 2010-04-10 17:21:54 EDT
Spec URL: http://rebus.fedorapeople.org/fedora/12/SPECS/scalpel.spec
SRPM URL: http://rebus.fedorapeople.org/fedora/12/SRPMS/scalpel-1.60-1.fc12.src.rpm

Hello,
please would you be so kind and do a formal review for this package?

Scalpel is a fast file carver that reads a database of header and footer
definitions and extracts matching files from a set of image files or raw
device files. Scalpel is independent on used file-system and will carve
files from FATx, NTFS, ext2/3, or raw partitions. It is useful for both
digital forensics investigation and file recovery.

rpmlint /home/rebus/rpmroot/SRPMS/scalpel-1.60-1.fc12.src.rpm /home/rebus/rpmroot/RPMS/i686/scalpel-1.60-1.fc12.i686.rpm /home/rebus/rpmroot/RPMS/i686/scalpel-debuginfo-1.60-1.fc12.i686.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.

Koji F12: http://koji.fedoraproject.org/koji/taskinfo?taskID=2107874
Koji F13: http://koji.fedoraproject.org/koji/taskinfo?taskID=2107879
Koji devel: http://koji.fedoraproject.org/koji/taskinfo?taskID=2107890

Best regards
Michal Ambroz
Comment 1 Pavel Alexeev 2010-08-24 09:41:51 EDT
Legend: + - Ok.
- - Error.
+/- - It item acceptable, but I strongly recommend enhancement.
= - N/A.
MUST Items

[+] MUST: rpmlint must be run on every package. The output should be posted in the review.

$ rpmlint *.rpm *.spec
scalpel.src: E: unknown-key (MD5
3 packages and 1 specfiles checked; 1 errors, 0 warnings.

Src.rpm package just need rebuild and error gone.

[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[-] MUST: The package must meet the Packaging Guidelines.
1) Tarball contain binary windows files - .exe and .dll. It is not acceptable for Fedora. At least you must delete it in %prep.

http://fedoraproject.org/wiki/Packaging/Guidelines#No_inclusion_of_pre-built_binaries_or_libraries

2) For what you are include scalpel.conf also in doc?
3) Lines
#BuildRequires:..                                                                                                                                                                                 
#Requires:....... 
is garbage.
4) You include patch without comment with link to bugtracker.
http://fedoraproject.org/wiki/Packaging/Guidelines#All_patches_should_have_an_upstream_bug_link_or_comment

[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[-] MUST: The License field in the package spec file must match the actual license.

Source tarball contain two files prioque.h and prioque.c with other author than scalpel and without licence mention. It require clarification.

[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

$ md5sum scalpel-1.60.tar.gz scalpel-1.60.tar.gz_RPM 
a0ad1ae3f709bb42d30ba2dee992c3b0  scalpel-1.60.tar.gz
a0ad1ae3f709bb42d30ba2dee992c3b0  scalpel-1.60.tar.gz_RPM

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[=] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[=] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[=] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[=] MUST: Packages must NOT bundle copies of system libraries.
[=] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[=] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings.
[-] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.

%attr specification is ambiguous in:
%attr(755,root,root) %{_bindir}/%{name} 

[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: Each package must consistently use macros.
[=] MUST: The package must contain code, or permissable content.
See licensing issues below.

[=] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[=] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[=] MUST: Header files must be in a -devel package.
[=] MUST: Static libraries must be in a -static package.
[=] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[=] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
[=] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
[=] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[=] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[=] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[+] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[+] MUST: All filenames in rpm packages must be valid UTF-8.

SHOULD Items:
[=] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[=] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[+] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[=] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[=] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[=] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[=] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

Some more things:
1) It is ambiguous explicit archiving man page because it will be done automatically.
2) If you do not plan maintain it for EPEL 4-5 (guess by presented builds) tag BuildRoot is ambiguous.
3) I have not completely understand what you are doing wit config on sed. Can you describe slightly?
Comment 2 Michal Ambroz 2010-08-24 13:06:26 EDT
Hello Pavel,
thank you for picking review of this package. The review is great and I will try to fix the issues.


>[+] MUST: rpmlint
>scalpel.src: E: unknown-key (MD5
Package is signed with my gpg id and rpmlint reports this as error, this shuold be gone when rebuilt by koji.

>[-] MUST: The package must meet the Packaging Guidelines.
>1) Tarball contain binary windows files in %prep.
fixed - deleted in prep phase

>2) For what you are include scalpel.conf also in doc?
For nothing. Original idea was to include sample config, but then I decided it would be better to have one usable global configuration out of the box so I patched the code for opening the configuration file

>3) Lines #BuildRequires: #Requires: is garbage.
Garbage out

>4) You include patch without comment with link to bugtracker.
There is no bugtracker for the package. 
I have sent now the patch to author to consider include it in the mainstream version and added comment.


>[-] MUST: The License field in the package spec file must match the actual license.
>Source tarball contain two files prioque.h and prioque.c with other author than
>scalpel and without licence mention. It require clarification.
I believe author of all files is the same - just he made Ph. D. (congratz Golden G. Richard III ! :) . Have you found it by some automated tool?
I will contact the author to consider putting the license to the files, but I assume it is not a problem right now.

>[-] MUST: Permissions on files must be set properly. Executables should be set
>%attr specification is ambiguous in:
>%attr(755,root,root) %{_bindir}/%{name} 
I do not understand what you mean - this executable will be set with 755 permissions ownership by root.
How ambiguous is that?

>Some more things:
>1) It is ambiguous explicit archiving man page because it will be done
>automatically.
Ok ... removed

>2) If you do not plan maintain it for EPEL 4-5 (guess by presented builds) tag
>BuildRoot is ambiguous.
I do plan to maintain for EPEL as well

>3) I have not completely understand what you are doing wit config on sed. Can
>you describe slightly?
I have put description to comments
In distribution configuration everything is commented out.
Sed will enable most of the file extensions to be found.

http://rebus.webz.cz/download.php?get=scalpel.spec
http://rebus.webz.cz/download.php?get=scalpel-1.60-2.fc13.src.rpm

Best regards
Michal Ambroz
Comment 3 Pavel Alexeev 2010-08-26 05:10:57 EDT
(In reply to comment #2)
> >[-] MUST: The License field in the package spec file must match the actual license.
> >Source tarball contain two files prioque.h and prioque.c with other author than
> >scalpel and without licence mention. It require clarification.
> I believe author of all files is the same - just he made Ph. D. (congratz
> Golden G. Richard III ! :) . Have you found it by some automated tool?

Sorry, really author the same. So, then it no problem if no other license mentioned.
And no, I found it manually - there very few files and check its is not so hard.

> >[-] MUST: Permissions on files must be set properly. Executables should be set
> >%attr specification is ambiguous in:
> >%attr(755,root,root) %{_bindir}/%{name} 
> I do not understand what you mean - this executable will be set with 755
> permissions ownership by root.
> How ambiguous is that?

Before that you already set up tis permissions on install:
install -m 755 %{name} %{buildroot}%{_bindir}/%{name}

Just for the info constructions like:
install -d %{buildroot}%{_bindir}
install -m 755 %{name} %{buildroot}%{_bindir}/%{name}

May be replaced by one line (with -D flag):
install -Dm 755 %{name} %{buildroot}%{_bindir}/%{name}

> >2) If you do not plan maintain it for EPEL 4-5 (guess by presented builds) tag
> >BuildRoot is ambiguous.
> I do plan to maintain for EPEL as well
Ok, then all fine there.

> >3) I have not completely understand what you are doing wit config on sed. Can
> >you describe slightly?
> I have put description to comments
> In distribution configuration everything is commented out.
> Sed will enable most of the file extensions to be found.
Ok. I believe you test it.


Now only ask to remove ambiguous attribute specification, otherwise package seams now fine.
Package APPROVED.
Comment 4 R P Herrold 2010-08-26 11:38:21 EDT
I get a patch application failure with  scalpel-1.60-2.fc13.src.rpm

   ...
+ patch -p1 -b --suffix .0conf -s
1 out of 1 hunk FAILED -- saving rejects to file scalpel.c.rej
error: Bad exit status from /var/tmp/rpm-tmp.56641 (%prep)


RPM build errors:
    Bad exit status from /var/tmp/rpm-tmp.56641 (%prep)

-------------------

The RPMforge packaging of this does not seem to have this
   /home/herrold/rpmbuild/SRPMS/scalpel-1.60-1.rf.src.rpm

-- Russ herrold
Comment 5 Michal Ambroz 2010-08-27 15:00:38 EDT
Hello Pavel,
(In reply to comment #3)
> Now only ask to remove ambiguous attribute specification, otherwise package
> seams now fine.

I agree it is duplicate, but it is not ambiguous - I do not see any other reading than that the permission is 755. 

Anyway it is not needed and I will remove it.
Comment 6 Michal Ambroz 2010-08-27 15:04:06 EDT
Hello R P
Thanks for trying. 

(In reply to comment #4)
> I get a patch application failure with  scalpel-1.60-2.fc13.src.rpm
I am sorry to hear that. May be I have got some strange char in the patch. I will doublecheck that.


> + patch -p1 -b --suffix .0conf -s
> 1 out of 1 hunk FAILED -- saving rejects to file scalpel.c.rej
Please what is your current patch,rpmbuild version - so I can try with the same to reproduce the error?

Are you using F13 or something else?

Best regards
Michal Ambroz
Comment 7 R P Herrold 2010-08-27 17:16:34 EDT
[herrold@centos-5 pw]$ rpm -q patch rpm-build centos-release
patch-2.5.4-29.2.3.el5
rpm-build-4.4.2.3-18.el5
centos-release-5-5.el5.centos
[herrold@centos-5 pw]$
Comment 8 Michal Ambroz 2010-08-31 20:23:19 EDT
Hello guys,
Spec URL: http://rebus.fedorapeople.org/fedora/13/SPECS/scalpel.spec
SRPM URL:
http://rebus.fedorapeople.org/fedora/13/SRPMS/scalpel-1.60-3.fc12.src.rpm

Please could you check this one?

- I have removed redundant attr permission definitions
- I was not able to reproduce the error, so I have at least tried to regenerate the patch to avoid some special characters or something like that

Michal Ambroz
Comment 9 Pavel Alexeev 2010-09-02 09:07:48 EDT
Src.rpm can't be downloaded - 404 error.
Comment 10 Michal Ambroz 2010-09-02 10:00:29 EDT
Sorry - problem between chair and the keyboard  on my side of internet.
Spec URL: http://rebus.fedorapeople.org/fedora/13/SPECS/scalpel.spec
SRPM URL:
http://rebus.fedorapeople.org/fedora/13/SRPMS/scalpel-1.60-3.fc13.src.rpm

Michal Ambroz
Comment 11 Pavel Alexeev 2010-09-02 10:20:30 EDT
On my look package now fine. Now you can request GIT branches as package approved.
Comment 12 Michal Ambroz 2010-09-03 05:18:32 EDT
New Package SCM Request
=======================
Package Name: scalpel
Short Description: Fast file carver working on disk images
Owners: rebus
Branches: f13 f14 el5 el6
InitialCC:
Comment 13 Michal Ambroz 2010-09-03 05:20:34 EDT
Thank you Pahan for review.

Please R P - did the regeneration of patch helped to build on centos 5?
Thank you
Michal Ambroz
Comment 14 Kevin Fenzi 2010-09-05 13:42:13 EDT
Git done (by process-git-requests).
Comment 15 Fedora Update System 2010-09-09 19:04:21 EDT
scalpel-1.60-3.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/scalpel-1.60-3.el5
Comment 16 Fedora Update System 2010-09-09 19:04:28 EDT
scalpel-1.60-3.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/scalpel-1.60-3.fc13
Comment 17 Fedora Update System 2010-09-09 19:04:34 EDT
scalpel-1.60-3.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/scalpel-1.60-3.fc14
Comment 18 Fedora Update System 2010-09-10 11:15:06 EDT
scalpel-1.60-3.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update scalpel'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/scalpel-1.60-3.fc14
Comment 19 Fedora Update System 2010-09-10 16:36:01 EDT
scalpel-1.60-3.el5 has been pushed to the Fedora EPEL 5 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update scalpel'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/scalpel-1.60-3.el5
Comment 20 Fedora Update System 2010-09-14 01:05:40 EDT
scalpel-1.60-3.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 21 R P Herrold 2010-09-14 12:40:58 EDT
reply to comment 13 -- 

no, but I will wait for the package to show up in the formal feed out of RawHide, and see 

-- thank you for looking
Comment 22 Michal Ambroz 2010-09-14 17:42:28 EDT
(In reply to comment #21)
Hello,
package should be already available in the testing EPEL5 repository.
yum --enablerepo=updates-testing update scalpel

Best regards
Michal Ambroz
Comment 23 Fedora Update System 2010-09-15 01:39:29 EDT
scalpel-1.60-3.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 24 Fedora Update System 2010-09-27 12:58:49 EDT
scalpel-1.60-3.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 25 Michal Ambroz 2014-09-23 14:10:52 EDT
Package Change Request
======================
Package Name: scalpel
New Branches: epel7
Owners: rebus

Hello SCM team,
plase can you add epel7 branch for the scalpel package?
Thank you
Michal Ambroz
Comment 26 Michal Ambroz 2014-09-23 14:11:32 EDT
Package Change Request
======================
Package Name: scalpel
New Branches: epel7
Owners: rebus

Hello SCM team,
plase can you add epel7 branch for the scalpel package?
Thank you
Michal Ambroz
Comment 27 Jon Ciesla 2014-09-23 15:17:00 EDT
Git done (by process-git-requests).
Comment 28 Fedora Update System 2014-09-29 12:59:17 EDT
scalpel-2.0-7.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/scalpel-2.0-7.el7
Comment 29 Fedora Update System 2014-10-17 13:39:19 EDT
scalpel-2.0-7.el7 has been pushed to the Fedora EPEL 7 stable repository.

Note You need to log in before you can comment on or make changes to this bug.